Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 2236)
@@ -25,44 +25,43 @@
    PRIVATE
 
-   PUBLIC sbc_rnf          ! routine call in step module
-
-   !                                                     !!* namsbc_rnf namelist *
+   PUBLIC sbc_rnf          ! routine call in sbcmod module
+   PUBLIC sbc_rnf_div      ! routine called in sshwzv module
+
+   !                                                      !!* namsbc_rnf namelist *
    CHARACTER(len=100), PUBLIC ::   cn_dir       = './'    !: Root directory for location of ssr files
+   LOGICAL           , PUBLIC ::   ln_rnf_depth = .false. !: depth       river runoffs attribute specified in a file
+   LOGICAL           , PUBLIC ::   ln_rnf_temp  = .false. !: temperature river runoffs attribute specified in a file 
+   LOGICAL           , PUBLIC ::   ln_rnf_sal   = .false. !: salinity    river runoffs attribute specified in a file 
    LOGICAL           , PUBLIC ::   ln_rnf_emp   = .false. !: runoffs into a file to be read or already into precipitation
    TYPE(FLD_N)       , PUBLIC ::   sn_rnf                 !: information about the runoff file to be read
    TYPE(FLD_N)       , PUBLIC ::   sn_cnf                 !: information about the runoff mouth file to be read
-   TYPE(FLD_N)                ::   sn_sal_rnf             !: information about the salinities of runoff file to be read  
-   TYPE(FLD_N)                ::   sn_tmp_rnf             !: information about the temperatures of runoff file to be read  
+   TYPE(FLD_N)                ::   sn_s_rnf               !: information about the salinities of runoff file to be read  
+   TYPE(FLD_N)                ::   sn_t_rnf               !: information about the temperatures of runoff file to be read  
    TYPE(FLD_N)                ::   sn_dep_rnf             !: information about the depth which river inflow affects
    LOGICAL           , PUBLIC ::   ln_rnf_mouth = .false. !: specific treatment in mouths vicinity
    REAL(wp)          , PUBLIC ::   rn_hrnf      = 0.e0    !: runoffs, depth over which enhanced vertical mixing is used
    REAL(wp)          , PUBLIC ::   rn_avt_rnf   = 0.e0    !: runoffs, value of the additional vertical mixing coef. [m2/s]
-   LOGICAL           , PUBLIC ::   ln_rnf_att   = .false. !: river runoffs attributes (temp, sal & depth) are specified in a file 
    REAL(wp)          , PUBLIC ::   rn_rfact     = 1.e0    !: multiplicative factor for runoff
 
-   INTEGER , PUBLIC                     ::   nkrnf = 0   !: number of levels over which Kz is increased at river mouths
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   rnfmsk      !: river mouth mask (hori.)
-   REAL(wp), PUBLIC, DIMENSION(jpk)     ::   rnfmsk_z    !: river mouth mask (vert.)
-
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_rnf        !: structure of input river runoff (file information, fields read)
-
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_sal_rnf    !: structure of input river runoff salinity (file information, fields read)  
-   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_tem_rnf    !: structure of input river runoff temperature (file information, fields read)  
+   INTEGER , PUBLIC                     ::   nkrnf = 0    !: number of levels over which Kz is increased at river mouths
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   rnfmsk       !: river mouth mask (hori.)
+   REAL(wp), PUBLIC, DIMENSION(jpk)     ::   rnfmsk_z     !: river mouth mask (vert.)
+
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_rnf       !: structure of input river runoff (file information, fields read)
+
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_s_rnf     !: structure of input river runoff salinity (file information, fields read)  
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_t_rnf     !: structure of input river runoff temperature (file information, fields read)  
  
-   REAL,    PUBLIC, DIMENSION(jpi,jpj) ::  rnf_dep         !: depth of runoff in m  
-   INTEGER, PUBLIC, DIMENSION(jpi,jpj) ::  rnf_mod_dep     !: depth of runoff in model levels  
-   REAL,    PUBLIC, DIMENSION(jpi,jpj) ::  rnf_sal         !: salinity of river runoff  
-   REAL,    PUBLIC, DIMENSION(jpi,jpj) ::  rnf_tmp         !: temperature of river runoff  
-  
-   INTEGER  ::  ji, jj ,jk    ! dummy loop indices  
-   INTEGER  ::  inum          ! temporary logical unit  
-  
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj) ::   h_rnf        !: depth of runoff in m
+   INTEGER,  PUBLIC, DIMENSION(jpi,jpj) ::   nk_rnf       !: depth of runoff in model levels
+
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,2) ::  tsc_rnf  !: temperature & salinity content of river runoffs   [K.m/s & PSU.m/s]
+
    !! * Substitutions  
 #  include "domzgr_substitute.h90"  
-
    !!----------------------------------------------------------------------
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -84,7 +83,8 @@
       !!
       INTEGER  ::   ji, jj   ! dummy loop indices
+      REAL(wp) ::   z1_rau0  ! local scalar
       !!----------------------------------------------------------------------
       !                                   
-      IF( kt == nit000 )  CALL sbc_rnf_init     ! Read namelist and allocate structures 
+      IF( kt == nit000 )   CALL sbc_rnf_init                           ! Read namelist and allocate structures
 
       !                                                   !-------------------!
@@ -92,10 +92,7 @@
          !                                                !-------------------!
          !
-         CALL fld_read( kt, nn_fsbc, sf_rnf )   ! Read Runoffs data and provides it
-         !                                      ! at the current time-step
-         IF ( ln_rnf_att ) THEN  
-            CALL fld_read ( kt, nn_fsbc, sf_sal_rnf )  
-            CALL fld_read ( kt, nn_fsbc, sf_tem_rnf )  
-         ENDIF  
+                             CALL fld_read ( kt, nn_fsbc, sf_rnf )      ! Read Runoffs data and provide it at kt 
+         IF( ln_rnf_temp )   CALL fld_read ( kt, nn_fsbc, sf_t_rnf )    ! idem for runoffs temperature if required
+         IF( ln_rnf_sal  )   CALL fld_read ( kt, nn_fsbc, sf_s_rnf )    ! idem for runoffs salinity    if required
 
          ! Runoff reduction only associated to the ORCA2_LIM configuration
@@ -113,12 +110,27 @@
          IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
             rnf(:,:)  = rn_rfact * ( sf_rnf(1)%fnow(:,:,1) )  
-            IF ( ln_rnf_att ) THEN  
-               rnf_sal(:,:) = ( sf_sal_rnf(1)%fnow(:,:,1) )  
-               rnf_tmp(:,:) = ( sf_tem_rnf(1)%fnow(:,:,1) )  
-            ELSE  
-               rnf_sal(:,:) = 0  
-               rnf_tmp(:,:) = -999  
+            !
+            z1_rau0 = 1.e0 / rau0
+            !                                                              ! set temperature & salinity content of runoffs
+            IF( ln_rnf_temp )   THEN                                       ! use runoffs temperature data
+               tsc_rnf(:,:,jp_tem) = ( sf_t_rnf(1)%fnow(:,:,1) ) * rnf(:,:) * z1_rau0
+               WHERE( sf_t_rnf(1)%fnow(:,:,1) == -999 )                      ! if missing data value use SST as runoffs temperature  
+                   tsc_rnf(:,:,jp_tem) = sst_m(:,:) * rnf(:,:) * z1_rau0
+               ENDWHERE
+            ELSE                                                           ! use SST as runoffs temperature
+               tsc_rnf(:,:,jp_tem) = sst_m(:,:) * rnf(:,:) * z1_rau0
             ENDIF  
-            CALL iom_put( "runoffs", rnf )         ! runoffs
+            !                                                              ! use runoffs salinity data 
+            IF( ln_rnf_sal ) tsc_rnf(:,:,jp_sal) = ( sf_s_rnf(1)%fnow(:,:,1) ) * rnf(:,:) * z1_rau0
+            !                                                              ! else use S=0 for runoffs (done one for all in the init)
+            !
+            IF( ln_rnf_temp .OR. ln_rnf_sal ) THEN                         ! runoffs as outflow: use ocean SST and SSS
+               WHERE( rnf(:,:) < 0.e0 )                                    ! example baltic model when flow is out of domain 
+                  tsc_rnf(:,:,jp_tem) = sst_m(:,:) * rnf(:,:) * z1_rau0
+                  tsc_rnf(:,:,jp_sal) = sss_m(:,:) * rnf(:,:) * z1_rau0
+               ENDWHERE
+            ENDIF
+
+            CALL iom_put( "runoffs", rnf )         ! output runoffs arrays
          ENDIF
          !
@@ -127,4 +139,52 @@
    END SUBROUTINE sbc_rnf
 
+   SUBROUTINE sbc_rnf_div( phdivn )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE sbc_rnf  ***
+      !!       
+      !! ** Purpose :   update the horizontal divergence with the runoff inflow
+      !!
+      !! ** Method  :   
+      !!                CAUTION : rnf is positive (inflow) decreasing the 
+      !!                          divergence and expressed in m/s
+      !!
+      !! ** Action  :   phdivn   decreased by the runoff inflow
+      !!----------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(inout) ::   phdivn   ! horizontal divergence
+      !!
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   z1_rau0   ! local scalar
+      !!----------------------------------------------------------------------
+      !
+      z1_rau0 = 1.e0 / rau0
+      IF( ln_rnf_depth ) THEN      !==   runoff distributed over several levels   ==!
+         IF( lk_vvl ) THEN             ! variable volume case 
+            DO jj = 1, jpj                   ! update the depth over which runoffs are distributed
+               DO ji = 1, jpi
+                  h_rnf(ji,jj) = 0.e0 
+                  DO jk = 1, nk_rnf(ji,jj)                           ! recalculates h_rnf to be the depth in metres
+                     h_rnf(ji,jj) = h_rnf(ji,jj) + fse3t(ji,jj,jk)   ! to the bottom of the relevant grid box 
+                  END DO 
+                  !                          ! apply the runoff input flow
+                  DO jk = 1, nk_rnf(ji,jj)
+                     phdivn(ji,jj,jk) = phdivn(ji,jj,jk) - rnf(ji,jj) * z1_rau0 / h_rnf(ji,jj)
+                  END DO
+               END DO
+            END DO
+         ELSE                          ! constant volume case : just apply the runoff input flow
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  DO jk = 1, nk_rnf(ji,jj)
+                     phdivn(ji,jj,jk) = phdivn(ji,jj,jk) - rnf(ji,jj) * z1_rau0 / h_rnf(ji,jj)
+                  END DO
+               END DO
+            END DO
+         ENDIF
+      ELSE                       !==   runoff put only at the surface   ==!
+         phdivn(:,:,1) = phdivn(:,:,1) - rnf(:,:) * z1_rau0 / fse3t(:,:,1)
+      ENDIF
+      !
+   END SUBROUTINE sbc_rnf_div
+
 
    SUBROUTINE sbc_rnf_init
@@ -138,9 +198,11 @@
       !! ** Action  : - read parameters
       !!----------------------------------------------------------------------
-      INTEGER  ::   ierror   ! temporary integer
       CHARACTER(len=32) ::   rn_dep_file   ! runoff file name  
+      INTEGER           ::   inum        ! temporary integers
+      INTEGER           ::   ierror   ! temporary integer
       !! 
-      NAMELIST/namsbc_rnf/ cn_dir, ln_rnf_emp, sn_rnf, sn_cnf, sn_sal_rnf, sn_tmp_rnf, sn_dep_rnf,   &  
-         &                 ln_rnf_mouth, ln_rnf_att, rn_hrnf, rn_avt_rnf, rn_rfact  
+      NAMELIST/namsbc_rnf/ cn_dir, ln_rnf_emp, ln_rnf_depth, ln_rnf_temp, ln_rnf_sal,   &
+         &                 sn_rnf, sn_cnf    , sn_s_rnf    , sn_t_rnf   , sn_dep_rnf,   &  
+         &                 ln_rnf_mouth      , rn_hrnf     , rn_avt_rnf , rn_rfact  
       !!----------------------------------------------------------------------
 
@@ -154,6 +216,6 @@
       sn_cnf = FLD_N( 'runoffs',     0     , 'sorunoff' ,  .FALSE.   , .true. ,   'yearly'  , ''       , ''         )
 
-      sn_sal_rnf = FLD_N( 'runoffs',  24.  , 'rosaline' ,  .TRUE.    , .true. ,   'yearly'  , ''    , ''  )  
-      sn_tmp_rnf = FLD_N( 'runoffs',  24.  , 'rotemper' ,  .TRUE.    , .true. ,   'yearly'  , ''    , ''  )  
+      sn_s_rnf = FLD_N( 'runoffs',  24.  , 'rosaline' ,  .TRUE.    , .true. ,   'yearly'  , ''    , ''  )  
+      sn_t_rnf = FLD_N( 'runoffs',  24.  , 'rotemper' ,  .TRUE.    , .true. ,   'yearly'  , ''    , ''  )  
       sn_dep_rnf = FLD_N( 'runoffs',   0.  , 'rodepth'  ,  .FALSE.   , .true. ,   'yearly'  , ''    , ''  )  
       !
@@ -178,61 +240,68 @@
       !                                   ! ==================
       !
-      IF( ln_rnf_emp ) THEN                     ! runoffs directly provided in the precipitations
+      IF( ln_rnf_emp ) THEN                     !==  runoffs directly provided in the precipitations  ==!
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) '          runoffs directly provided in the precipitations'
-         IF ( ln_rnf_att ) THEN
-           CALL ctl_warn( 'runoffs already included in precipitations & so runoff attributes will not be used' ) 
-           ln_rnf_att = .FALSE.
-         ENDIF
-         !
-      ELSE                                      ! runoffs read in a file : set sf_rnf structure 
-         !
-         ! Allocate sf_rnf structure and (if required) sf_sal_rnf and sf_tem_rnf structures
-         ALLOCATE( sf_rnf(1), STAT=ierror )
+         IF( ln_rnf_depth .OR. ln_rnf_temp .OR. ln_rnf_sal ) THEN
+           CALL ctl_warn( 'runoffs already included in precipitations, so runoff (T,S, depth) attributes will not be used' ) 
+           ln_rnf_depth = .FALSE.   ;   ln_rnf_temp = .FALSE.   ;   ln_rnf_sal = .FALSE.
+         ENDIF
+         !
+      ELSE                                      !==  runoffs read in a file : set sf_rnf structure  ==!
+         !
+         ALLOCATE( sf_rnf(1), STAT=ierror )         ! Create sf_rnf structure (runoff inflow)
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) '          runoffs inflow read in a file'
          IF( ierror > 0 ) THEN
             CALL ctl_stop( 'sbc_rnf: unable to allocate sf_rnf structure' )   ;   RETURN
          ENDIF
-         ALLOCATE( sf_rnf(1)%fnow(jpi,jpj,1) )
-         ALLOCATE( sf_rnf(1)%fdta(jpi,jpj,1,2) )
-
-         IF( ln_rnf_att ) THEN
-            ALLOCATE( sf_sal_rnf(1), STAT=ierror )
+         ALLOCATE( sf_rnf(1)%fnow(jpi,jpj,1)   )
+         IF( sn_rnf%ln_tint ) ALLOCATE( sf_rnf(1)%fdta(jpi,jpj,1,2) )
+         !                                          ! fill sf_rnf with the namelist (sn_rnf) and control print
+         CALL fld_fill( sf_rnf, (/ sn_rnf /), cn_dir, 'sbc_rnf_init', 'read runoffs data', 'namsbc_rnf' )
+         !
+         IF( ln_rnf_temp ) THEN                     ! Create (if required) sf_t_rnf structure
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) '          runoffs temperatures read in a file'
+            ALLOCATE( sf_t_rnf(1), STAT=ierror  )
             IF( ierror > 0 ) THEN
-               CALL ctl_stop( 'sbc_sal_rnf: unable to allocate sf_sal_rnf structure' )   ;   RETURN
+               CALL ctl_stop( 'sbc_rnf_init: unable to allocate sf_t_rnf structure' )   ;   RETURN
             ENDIF
-            ALLOCATE( sf_sal_rnf(1)%fnow(jpi,jpj,1) )
-            ALLOCATE( sf_sal_rnf(1)%fdta(jpi,jpj,1,2) )
-
-            ALLOCATE( sf_tem_rnf(1), STAT=ierror )
+            ALLOCATE( sf_t_rnf(1)%fnow(jpi,jpj,1)   )
+            IF( sn_t_rnf%ln_tint ) ALLOCATE( sf_t_rnf(1)%fdta(jpi,jpj,1,2) )
+            CALL fld_fill (sf_t_rnf, (/ sn_t_rnf /), cn_dir, 'sbc_rnf_init', 'read runoff temperature data', 'namsbc_rnf' )  
+         ENDIF
+         !
+         IF( ln_rnf_sal  ) THEN                     ! Create (if required) sf_s_rnf and sf_t_rnf structures
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) '          runoffs salinities read in a file'
+            ALLOCATE( sf_s_rnf(1), STAT=ierror  )
             IF( ierror > 0 ) THEN
-                CALL ctl_stop( 'sbc_tmp_rnf: unable to allocate sf_tem_rnf structure' )   ;   RETURN
+               CALL ctl_stop( 'sbc_rnf_init: unable to allocate sf_s_rnf structure' )   ;   RETURN
             ENDIF
-            ALLOCATE( sf_tem_rnf(1)%fnow(jpi,jpj,1) )
-            ALLOCATE( sf_tem_rnf(1)%fdta(jpi,jpj,1,2) )
-         ENDIF
-         ! fill sf_rnf with sn_rnf and control print
-         CALL fld_fill( sf_rnf, (/ sn_rnf /), cn_dir, 'sbc_rnf_init', 'read runoffs data', 'namsbc_rnf' )
+            ALLOCATE( sf_s_rnf(1)%fnow(jpi,jpj,1)   )
+            IF( sn_s_rnf%ln_tint ) ALLOCATE( sf_s_rnf(1)%fdta(jpi,jpj,1,2) )
+            CALL fld_fill (sf_s_rnf, (/ sn_s_rnf /), cn_dir, 'sbc_rnf_init', 'read runoff salinity data', 'namsbc_rnf' )  
+         ENDIF
+
  
-         IF ( ln_rnf_att ) THEN  
-            CALL fld_fill (sf_sal_rnf, (/ sn_sal_rnf /), cn_dir, 'sbc_rnf_init', 'read runoff salinity data', 'namsbc_rnf' )  
-            CALL fld_fill (sf_tem_rnf, (/ sn_tmp_rnf /), cn_dir, 'sbc_rnf_init', 'read runoff temperature data', 'namsbc_rnf' )  
-  
+         IF ( ln_rnf_depth ) THEN                     ! depth of runoffs set from a file 
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) '          runoffs depth read in a file'
             rn_dep_file = TRIM( cn_dir )//TRIM( sn_dep_rnf%clname )  
             CALL iom_open ( rn_dep_file, inum )                           ! open file  
-            CALL iom_get  ( inum, jpdom_data, sn_dep_rnf%clvar, rnf_dep )    ! read the river mouth array  
+            CALL iom_get  ( inum, jpdom_data, sn_dep_rnf%clvar, h_rnf )    ! read the river mouth array  
             CALL iom_close( inum )                                      ! close file  
   
-            rnf_mod_dep(:,:) = 0.  
-            DO jj = 1, jpj  
-              DO ji = 1, jpi  
-                IF ( rnf_dep(ji,jj) > 0.e0 ) THEN  
-                  jk = 2  
-                  DO WHILE ( jk /= jpkm1 .AND. fsdept(ji,jj,jk) < rnf_dep(ji,jj) ) ;  jk = jk + 1 ;   ENDDO  
-                  rnf_mod_dep(ji,jj) = jk  
-                ELSE IF ( rnf_dep(ji,jj) == -1. ) THEN  
-                  rnf_mod_dep(ji,jj) = 1.  
-                ELSE IF ( rnf_dep(ji,jj) == -999 ) THEN  
-                  rnf_mod_dep(ji,jj) = jpkm1  
-                ELSE IF ( rnf_dep(ji,jj) /= 0. ) THEN  
+            nk_rnf(:,:)=0                              ! set the number of level over which river runoffs are applied
+            DO jj=1,jpj  
+              DO ji=1,jpi  
+                IF ( h_rnf(ji,jj) > 0.e0 ) THEN  
+                  jk=2  
+                  DO WHILE ( jk/=(mbathy(ji,jj)-1) .AND. fsdept(ji,jj,jk) < h_rnf(ji,jj) );  jk=jk+1;   ENDDO  
+                  nk_rnf(ji,jj)=jk  
+                ELSE IF ( h_rnf(ji,jj) == -1   ) THEN   ;  nk_rnf(ji,jj)=1  
+                ELSE IF ( h_rnf(ji,jj) == -999 ) THEN   ;  nk_rnf(ji,jj)=mbathy(ji,jj)-1
+                ELSE IF ( h_rnf(ji,jj) /= 0 ) THEN  
                   CALL ctl_stop( 'runoff depth not positive, and not -999 or -1, rnf value in file fort.999'  )  
                   WRITE(999,*) 'ji, jj, rnf(ji,jj) :', ji, jj, rnf(ji,jj)  
@@ -240,11 +309,20 @@
               ENDDO  
             ENDDO  
-         ELSE  
-            rnf_mod_dep(:,:) = 1.  
+            DO jj=1,jpj                               ! set the associated depth 
+              DO ji=1,jpi 
+                h_rnf(ji,jj)=0.e0
+                DO jk=1,nk_rnf(ji,jj)                        
+                   h_rnf(ji,jj)=h_rnf(ji,jj)+fse3t(ji,jj,jk)  
+                ENDDO
+              ENDDO
+            ENDDO
+         ELSE                                       ! runoffs applied at the surface 
+            nk_rnf(:,:)=1  
+            h_rnf(:,:)=fse3t(:,:,1)
          ENDIF  
       ! 
       ENDIF
-      !
-
+
+      tsc_rnf(:,:,:) = 0.e0                 ! runoffs temperature & salinty contents initilisation
       !                                   ! ========================
       !                                   !   River mouth vicinity
@@ -256,8 +334,8 @@
          !                                      !    - mixed upstream-centered (ln_traadv_cen2=T)
          !
-         !                                          ! Number of level over which Kz increase
-         IF ( ln_rnf_att )  &  
-              &  CALL ctl_warn( 'increased mixing turned on but effects may already be spread through depth by ln_rnf_att' ) 
-         nkrnf = 0
+         IF ( ln_rnf_depth )   CALL ctl_warn( 'sbc_rnf_init: increased mixing turned on but effects may already',   &
+            &                                              'be spread through depth by ln_rnf_depth'               ) 
+         !
+         nkrnf = 0                                  ! Number of level over which Kz increase
          IF( rn_hrnf > 0.e0 ) THEN
             nkrnf = 2
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SBC/sbcssm.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 2236)
@@ -29,5 +29,5 @@
    !!   OPA 9.0 , LOCEAN-IPSL (2006) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SBC/sbcssr.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 2236)
@@ -48,5 +48,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -115,9 +115,9 @@
                CALL ctl_stop( 'sbc_ssr: unable to allocate sf_sst structure' )   ;   RETURN
             ENDIF
-            ALLOCATE( sf_sst(1)%fnow(jpi,jpj,1  ) )
-            ALLOCATE( sf_sst(1)%fdta(jpi,jpj,1,2) )
+            ALLOCATE( sf_sst(1)%fnow(jpi,jpj,1) )
             !
             ! fill sf_sst with sn_sst and control print
             CALL fld_fill( sf_sst, (/ sn_sst /), cn_dir, 'sbc_ssr', 'SST restoring term toward SST data', 'namsbc_ssr' )
+            IF( sf_sst(1)%ln_tint ) ALLOCATE( sf_sst(1)%fdta(jpi,jpj,1,2) )
          ENDIF
          !
@@ -128,9 +128,9 @@
                CALL ctl_stop( 'sbc_ssr: unable to allocate sf_sss structure' )   ;   RETURN
             ENDIF
-            ALLOCATE( sf_sss(1)%fnow(jpi,jpj,1  ) )
-            ALLOCATE( sf_sss(1)%fdta(jpi,jpj,1,2) )
+            ALLOCATE( sf_sss(1)%fnow(jpi,jpj,1) )
             !
             ! fill sf_sss with sn_sss and control print
             CALL fld_fill( sf_sss, (/ sn_sss /), cn_dir, 'sbc_ssr', 'SSS restoring term toward SSS data', 'namsbc_ssr' )
+            IF( sf_sss(1)%ln_tint )ALLOCATE( sf_sss(1)%fdta(jpi,jpj,1,2) )
          ENDIF
          !
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/sol_oce.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/sol_oce.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/sol_oce.F90	(revision 2236)
@@ -52,5 +52,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 END MODULE sol_oce
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solmat.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solmat.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solmat.F90	(revision 2236)
@@ -15,4 +15,5 @@
    !!             3.2  ! 2009-06  (S. Masson)  distributed restart using iom
    !!              -   ! 2009-07  (R. Benshila)  suppression of rigid-lid option
+   !!             3.3  ! 2010-09  (D. Storkey) update for BDY module.
    !!----------------------------------------------------------------------
 
@@ -26,4 +27,5 @@
    USE phycst          ! physical constants
    USE obc_oce         ! ocean open boundary conditions
+   USE bdy_oce         ! unstructured open boundary conditions
    USE lbclnk          ! lateral boudary conditions
    USE lib_mpp         ! distributed memory computing
@@ -38,5 +40,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt) 
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt) 
    !!----------------------------------------------------------------------
 
@@ -80,5 +82,5 @@
       ENDIF
 
-#if defined key_dynspg_flt 
+#if defined key_dynspg_flt && ! defined key_bdy
 #   if ! defined key_obc
 
@@ -158,4 +160,38 @@
     ENDIF
 #   endif
+
+#  elif defined key_dynspg_flt && defined key_bdy 
+
+      !   defined gcdmat in the case of unstructured open boundaries
+      DO jj = 2, jpjm1
+         DO ji = 2, jpim1
+            zcoef = z2dt * z2dt * grav * bmask(ji,jj)
+
+            !  south coefficient
+            zcoefs = -zcoef * hv(ji,jj-1) * e1v(ji,jj-1)/e2v(ji,jj-1)
+            zcoefs = zcoefs * bdyvmask(ji,jj-1)
+            gcp(ji,jj,1) = zcoefs
+
+            !  west coefficient
+            zcoefw = -zcoef * hu(ji-1,jj) * e2u(ji-1,jj)/e1u(ji-1,jj)
+            zcoefw = zcoefw * bdyumask(ji-1,jj)
+            gcp(ji,jj,2) = zcoefw
+
+            !  east coefficient
+            zcoefe = -zcoef * hu(ji,jj) * e2u(ji,jj)/e1u(ji,jj)
+            zcoefe = zcoefe * bdyumask(ji,jj)
+            gcp(ji,jj,3) = zcoefe
+
+            !  north coefficient
+            zcoefn = -zcoef * hv(ji,jj) * e1v(ji,jj)/e2v(ji,jj)
+            zcoefn = zcoefn * bdyvmask(ji,jj)
+            gcp(ji,jj,4) = zcoefn
+
+            ! diagonal coefficient
+            gcdmat(ji,jj) = e1t(ji,jj)*e2t(ji,jj)*bmask(ji,jj) &
+                            - zcoefs -zcoefw -zcoefe -zcoefn
+         END DO
+      END DO
+
 #endif
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solpcg.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solpcg.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solpcg.F90	(revision 2236)
@@ -26,5 +26,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solsor.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solsor.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solsor.F90	(revision 2236)
@@ -32,5 +32,5 @@
    !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solver.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solver.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/SOL/solver.F90	(revision 2236)
@@ -33,5 +33,5 @@
    !! NEMO/OPA 9.0 , LOCEAN-IPSL (2009) 
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/eosbn2.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 2236)
@@ -64,5 +64,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv.F90	(revision 2236)
@@ -51,5 +51,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -83,10 +83,10 @@
       zwn(:,:,jpk) = 0.e0                                                     ! no transport trough the bottom
       !
-      IF( lk_traldf_eiv )   CALL tra_adv_eiv( kt, zun, zvn, zwn, 'TRA' )      ! add the eiv transport (if necessary)
+      IF( lk_traldf_eiv .AND. .NOT. ln_traldf_grif )   &
+         &                  CALL tra_adv_eiv( kt, zun, zvn, zwn, 'TRA' )      ! add the eiv transport (if necessary)
       !
       CALL iom_put( "uoce_eff", zun )                                         ! output effective transport      
       CALL iom_put( "voce_eff", zvn )
       CALL iom_put( "woce_eff", zwn )
-
 
       SELECT CASE ( nadv )                            !==  compute advection trend and add it to general trend  ==!
@@ -97,4 +97,5 @@
       CASE ( 5 )   ;    CALL tra_adv_ubs   ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  UBS 
       CASE ( 6 )   ;    CALL tra_adv_qck   ( kt, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts )   !  QUICKEST 
+
       !
       CASE (-1 )                                      !==  esopa: test all possibility with control print  ==!
Index: branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_cen2.F90
===================================================================
--- branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 2230)
+++ branches/DEV_r2106_LOCEAN2010/NEMO/OPA_SRC/TRA/traadv_cen2.F90	(revision 2236)
@@ -48,5 +48,5 @@
    !! NEMO/OPA 3.3 , LOCEAN-IPSL (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence  (NEMOGCM/License_CeCILL.txt)
    !!----------------------------------------------------------------------
 
